Subject: Re: [PATCH 1/5] [VLAN]: Unclassified vlan packet

From: Patrick McHardy <[email-masked]>
Date: Tue, 27 May 2008 08:30:23 +0200

Joonwoo Park wrote:
> 2008/5/26 Patrick McHardy <[email-masked]>:
>> Joonwoo Park wrote:
>>> To be polite to the PACKET,
>>> Don't kill the unclassified & hardware accelerated vlan packets if netdev
>>> is in promiscuous, set packet type with PACKET_OTHERHOST. Put the vlan tag
>>> into skb->cb for all hardware accelerated vlan packets.
>> Conceptually I think this patch goes in the right direction,
>> one question remaining is when to invalidate the VLAN tag again.
>>
>> The only solution I could come up with is invalidating it in
>> netif_receive_skb() when the receiving device is not a VLAN
>> device and additionally invalidating it in all callers of
>> dev_queue_xmit except VLAN itself, but I would really prefer
>> something less error prone without touching netif_receive_skb().
>>
>> BTW, I already have a patch queued to move the VLAN tag from
>> skb->cb to a seperate skb member to fix the the conflict with
>> qdiscs (this should also allow to use vlan accel through virtual
>> network devices later on). So please don't resend, I'll integrate
>> the patch on top of this change once we find a good spot for
>> invalidation.
>>
> 
> Thanks Patrick for reviewing.
> I'll be looking forward to seeing it on the list.

Well, we still need to find a good spot for invalidation.
Suggestions welcome :)